/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : Animation.h

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  28/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/

#ifndef __ANIMATION_H__
#define __ANIMATION_H__

#include <string>
#include "../utils/Point.h"
#include "../managers/TextureManager.h"


// ==============================================
// CAnimation - 
// ==============================================
class CAnimation
{
public:
	CAnimation(float x, float y, float z, int width, int height,std::string texName, int number);
	~CAnimation(void);

	void Update(Uint32 time);
	void Draw(void);

protected:
	int m_iPicturesNumber;
	int m_iCurrentIndex;
	int m_iTextureID[50];
	int m_iTimeStep;
	int m_iCurrentTime;
	CPoint3D<float> m_vPosition;
	float m_fWidth;
	float m_fHeight;

	void SetWidth(float width);
	void SetHeight(float height);
	void SetTimeStep(int timestep);
	void SetPosition(CPoint3D<float> position);

	float Width();
	float Height();
	CPoint3D<float> Position();
	int TimeStep();
	int PicturesNumber();

};

#endif // _ANIMATION_H__



/****************************************************************************
 *                                                                          *
 *  NOTES :                                                                 *
 *                                                                          *
 ****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *    
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *         
 *                                                                          *    
 ****************************************************************************/