/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : GCursor.cpp

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  24/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/

#include "GCursor.h"

/****************************************************************************
 *                                                                          *
 *    Function     : GCursor                                                * 
 *                                                                          *
 *    Description  : Class construtor                                       *
 *                                                                          *
 *    Interface    :                                                        *
 *                                                                          *
 *    Return Value :                                                        *
 *                                                                          *
 ****************************************************************************/
GCursor::GCursor(void):
m_bVisible(true),
m_iTextureId(0),
m_iSize(20)
{
}


/****************************************************************************
 *                                                                          *
 *    Function     : render                                                 * 
 *                                                                          *
 *    Description  :                                                        *
 *                                                                          *
 *    Interface    :                                                        *
 *                                                                          *
 *    Return Value :                                                        *
 *                                                                          *
 ****************************************************************************/
void GCursor::render(int x, int y)
{	
	m_cPosition.set(x,y);
	render();
}


/****************************************************************************
 *                                                                          *
 *    Function     : render                                                 * 
 *                                                                          *
 *    Description  :                                                        *
 *                                                                          *
 *    Interface    :                                                        *
 *                                                                          *
 *    Return Value :                                                        *
 *                                                                          *
 ****************************************************************************/
void GCursor::render()
{	
	if (m_bVisible)
	{
		glActiveTextureARB( GL_TEXTURE0_ARB );
        glEnable(GL_TEXTURE_2D);
		glColor4f(1.0f, 1.0f, 1.0f, m_fTransparency);
		glBindTexture(GL_TEXTURE_2D, m_iTextureId);

		glBegin( GL_QUADS );
				glMultiTexCoord2fARB(GL_TEXTURE0_ARB, 0.0f,1.0f);
				glVertex2i(m_cPosition.X(),m_cPosition.Y()-m_iSize);
				glMultiTexCoord2fARB(GL_TEXTURE0_ARB, 1.0f,1.0f);
				glVertex2i(m_cPosition.X()+m_iSize,m_cPosition.Y()-m_iSize);
				glMultiTexCoord2fARB(GL_TEXTURE0_ARB, 1.0f,0.0f);
				glVertex2i(m_cPosition.X()+m_iSize,m_cPosition.Y());
				glMultiTexCoord2fARB(GL_TEXTURE0_ARB, 0.0f,0.0f);
				glVertex2i(m_cPosition.X(),m_cPosition.Y());
		glEnd();

		glDisable(GL_TEXTURE_2D);
	}
}


/****************************************************************************
 *                                                                          *
 *    Function     : load                                                   * 
 *                                                                          *
 *    Description  :                                                        *
 *                                                                          *
 *    Interface    :                                                        *
 *                                                                          *
 *    Return Value :                                                        *
 *                                                                          *
 ****************************************************************************/
bool GCursor::load(std::string name)
{	
	CTextureManager *pTex = CTextureManager::GetInstance();
	m_iTextureId = pTex->index(name);
	return true;
}