/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : GCursor.h

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  24/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/


#ifndef _GRAPHIC_CURSOR_H__
#define _GRAPHIC_CURSOR_H__ 1

#include <string>
#include "../utils/point.h"
#include "../managers/texturemanager.h"


// ==============================================
// GCursor - Cursor for user interface
// ==============================================
class GCursor
{
public:
	GCursor(void);
	~GCursor(void) {}

	bool isVisible() { return m_bVisible; }
	void setVisible(bool state) { m_bVisible = state; }
	int size() { return m_iSize; }
	void setSize(int size) { if (size>0) m_iSize = size; }
	void setPosition(int x, int y) { m_cPosition.setX(x); m_cPosition.setY(y); }

	CPoint2D<int> position() const { return m_cPosition; }

	bool load(std::string name);
	float transparency() const { return m_fTransparency; }
	void setTransparency(float alpha){m_fTransparency = alpha;}

	void render();
	void render(int x, int y);
	void render(CPoint2D<int> cursor) { render(cursor.X(), cursor.Y()); }

protected:
	bool m_bVisible;
	CPoint2D<int> m_cPosition;
	int m_iTextureId;
	int m_iSize;
	float m_fTransparency;
};



#endif



/****************************************************************************
 *                                                                          *
 *  NOTES :                                                                 *
 *                                                                          *
 ****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *    
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *         
 *                                                                          *    
 ****************************************************************************/
