/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : TextureManager.h

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  24/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/


#ifndef _TEXTURE_MANAGER_H__
#define _TEXTURE_MANAGER_H__ 1

#include <stdio.h>
#include <string>
#include <map>
#include "../global.h"
#include "IL/ilu.h"
#include "IL/ilut.h"
#include "TINYXML/tinyxml.h"
#include "../utils/singleton.h"

// ==============================================
// CTextureManager - Gestionnaire de textures OGL.
// ==============================================
class CTextureManager :
	public CSingleton<CTextureManager>
{
	friend class CSingleton<CTextureManager>;

protected:
	// constructeur/destructeur
	CTextureManager(void);
	virtual ~CTextureManager(void);

public:
	// mthodes publiques
	GLuint load(std::string name);
	GLuint load(std::string name, std::string fileName);
	bool readFile(std::string fileName);

    GLuint index(std::string name);
    const char* name(GLuint id);

    bool del(std::string name);
    bool del(GLuint id);
	void release(void);

	inline GLuint count();

	void bind(std::string name);
	void bind(GLuint id);

	void capture();

protected:
	void initialize(void);

	std::map<std::string, GLuint>::iterator m_Iter;
	std::map<std::string, GLuint> m_TextureTable;

};

inline GLuint CTextureManager::count()
{
	return (GLuint)m_TextureTable.size();
}

#endif



/****************************************************************************
 *                                                                          *
 *  NOTES :                                                                 *
 *                                                                          *
 ****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *    
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *         
 *                                                                          *    
 ****************************************************************************/
