/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : PObject.h

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  25/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/


#ifndef _PHYSIC_OBJECT_H__
#define _PHYSIC_OBJECT_H__ 1

#include "ODE/ode.h"

// ==============================================
// PObject - Physical Object
// ==============================================
class PObject
{
public:
	PObject(void):identifier(0),isStatic(true),geomID(0),bodyID(0),mass(1.0f),x(0.0f),y(0.0f),
				z(1.0f),l(1.0f),L(1.0f),h(0.0f),radius(1.0f),a(0.0f),b(0.0f),c(0.0f),d(0.0f),
				type(Sphere),fx(0.0f),fy(0.0f),fz(0.0f),tx(0.0f),ty(0.0f),tz(0.0f){}
	~PObject(void){}

	int   identifier;
	bool  isStatic;
	dGeomID geomID;
	dBodyID bodyID;
	float mass;
	float x,y,z;
	float l,L,h;
	float radius;
	float a,b,c,d;
	float fx,fy,fz; //force
	float tx,ty,tz; //torque

	enum PObjectType{Sphere=0,Box,Cylinder,CappedCylinder,Plane};
	PObjectType type;
};



#endif



/****************************************************************************
 *                                                                          *
 *  NOTES :                                                                 *
 *                                                                          *
 ****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *    
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *         
 *                                                                          *    
 ****************************************************************************/
