/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : BaseProcess.h

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  24/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/


#ifndef _BASEPROCESS_H__
#define _BASEPROCESS_H__ 1

#include "../global.h"

class CBaseProcess
{
public:
	enum type {NoProcess,LoadingProcess,IntroProcess,MenuProcess,GameProcess,EndProcess};
	enum state {None, Done, Running, Paused, Quit};
	CBaseProcess(void);
	virtual ~CBaseProcess(void);
	virtual bool init(void);
	virtual void paint(void);
	virtual void update(Uint32 time);
	void start(void);
	virtual void terminate(void);
	const CBaseProcess::type getType(void);
	const CBaseProcess::state getState(void);
	virtual void keyDownEvent(SDL_KeyboardEvent* key);
	virtual void keyUpEvent(SDL_KeyboardEvent* key);
	virtual void mouseButtonDownEvent(SDL_MouseButtonEvent* button);
	virtual void mouseButtonUpEvent(SDL_MouseButtonEvent* button);
	virtual void mouseMotionEvent(SDL_MouseMotionEvent* motion);

protected:
	virtual void initOGL(void);
	virtual void initGameState(void);
	type m_eType;
	state m_eState;
};

#endif




/****************************************************************************
 *                                                                          *
 *  NOTES :                                                                 *
 *                                                                          *
 ****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *    
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *         
 *                                                                          *    
 ****************************************************************************/
