/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : IntroProcess.h

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  24/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/


#ifndef _INTRO_PROCESS_H__
#define _INTRO_PROCESS_H__ 1

#include "baseprocess.h"

/* Note : for debuging mode, comment the #define line. Else, long compilation time needed (2-3 minutes) */
#define __FLOTTE__         1 


#if __FLOTTE__
#include "../3d/Flotte.h"
#endif

class CIntroProcess :
	public CBaseProcess
{
public:
	CIntroProcess(void);
	virtual ~CIntroProcess(void);
	bool init(void);
	void paint(void);
	void terminate(void);
	void update(Uint32 time);
	void keyDownEvent(SDL_KeyboardEvent* key);
	void keyUpEvent(SDL_KeyboardEvent* key);
	void mouseButtonDownEvent(SDL_MouseButtonEvent* button);
	void mouseButtonUpEvent(SDL_MouseButtonEvent* button);
	void mouseMotionEvent(SDL_MouseMotionEvent* motion);
protected:
	void initOGL(void);
	void initGameState(void);

	#if __FLOTTE__
	dmFlotte *gFlotte;
	#endif

	Uint32 timeUsed;
	float m_fDelta;
	float m_fAlpha;
};

#endif




/****************************************************************************
 *                                                                          *
 *  NOTES :                                                                 *
 *                                                                          *
 ****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *    
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *         
 *                                                                          *    
 ****************************************************************************/