/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : LoadingProcess.h

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  24/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/

#ifndef _LOADINGPROCESS_H__
#define _LOADINGPROCESS_H__ 1

#include "baseprocess.h"

class CLoadingProcess :
	public CBaseProcess
{
public:
	CLoadingProcess(void);
	virtual ~CLoadingProcess(void);
	bool init(void);
	void paint(void);
	void update(Uint32 time);
	void keyDownEvent(SDL_KeyboardEvent* key);
	void keyUpEvent(SDL_KeyboardEvent* key);
	void mouseButtonDownEvent(SDL_MouseButtonEvent* button);
	void mouseButtonUpEvent(SDL_MouseButtonEvent* button);
	void mouseMotionEvent(SDL_MouseMotionEvent* motion);
	void terminate(void);
protected:
	void initOGL(void);
	void initGameState(void);
	Uint32 m_iTimePast;
	GLuint texture;

};


#endif



/****************************************************************************
 *                                                                          *
 *  NOTES :                                                                 *
 *                                                                          *
 ****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *    
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *         
 *                                                                          *    
 ****************************************************************************/