/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : MenuProcess.h

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  24/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/


#ifndef _MENU_PROCESS_H__
#define _MENU_PROCESS_H__ 1

#include "baseprocess.h"
#include "../gui/GCursor.h"
#include "../gui/GPushButton.h"


class CMenuProcess :
	public CBaseProcess
{
public:
	CMenuProcess(void);
	virtual ~CMenuProcess(void);
	bool init(void);
	void paint(void);
	void update(Uint32 time);
	void keyDownEvent(SDL_KeyboardEvent* key);
	void keyUpEvent(SDL_KeyboardEvent* key);
	void mouseButtonDownEvent(SDL_MouseButtonEvent* button);
	void mouseButtonUpEvent(SDL_MouseButtonEvent* button);
	void mouseMotionEvent(SDL_MouseMotionEvent* motion);

protected:
	void initOGL(void);
	void initGameState(void);

	// GUI functions (draw)
	void paintScrAnim();
	void paintScrNewGame();
	void paintScrScores();
	void paintScrQuit();
	void paintScrAbort();


	// GUI functions (actions)
	void actionNewGame( int window, int button ); 
	void actionQuit( int window, int button ); 

	// GUI attributes
	GCursor     m_cCursor;
	GPushButton *p_NewGameButton;
	GPushButton *p_QuitButton;

	int m_iGCNTextureId;
};



#endif



/****************************************************************************
 *                                                                          *
 *  NOTES :                                                                 *
 *                                                                          *
 ****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *    
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *         
 *                                                                          *    
 ****************************************************************************/