/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : Rectangle.h

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  24/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/

#ifndef _RECTANGLE_H__
#define _RECTANGLE_H__

#include"Point.h"

// ==============================================
// CRectangle - Rectangle
// ==============================================
template<class T> class CRectangle
{
public:
	inline CRectangle() {} 
	inline CRectangle(const CPoint2D<T> &p1, const CPoint2D<T> &p2 ) { set(p1,p2); } 
	inline CRectangle(T x1, T y1, T x2,T y2)                         { set(x1, y1, x2, y2); } 

	inline T width() const                                           { return ( _rightTopCorner.X() - _leftBottomCorner.X() ) ;}
	inline T height() const                                          { return ( _rightTopCorner.Y() - _leftBottomCorner.Y() ) ;}

	inline void set(T x1, T y1, T x2,T y2)
	{
		_leftBottomCorner = CPoint2D<T>(x1, y1);
		_rightTopCorner   = CPoint2D<T>(x2, y2);
	}

	inline void set(const CPoint2D<T> &p1, const CPoint2D<T> &p2 )
	{
		_leftBottomCorner = CPoint2D<T>(p1);
		_rightTopCorner   = CPoint2D<T>(p2);
	} 

	inline void setLeftBottonCorner(const CPoint2D<T> &p) {_leftBottomCorner = CPoint2D<T>(p); }
	inline void setRightTopCorner(const CPoint2D<T> &p) {_rightTopCorner = CPoint2D<T>(p); }

	inline CPoint2D<T> position() const { return _leftBottomCorner; }
	inline CPoint2D<T> position2() const { return _rightTopCorner; }

	inline void translate(T x, T y)
	{
		CPoint2D<T> translationVector = CPoint2D<T>(x,y);
		_leftBottomCorner = _leftBottomCorner + translationVector;
		_rightTopCorner = _rightTopCorner + translationVector;
	}

	inline bool inside(T x, T y)
	{
		if ( x > _leftBottomCorner.X() && x < _rightTopCorner.X() && y > _leftBottomCorner.Y() && y < _rightTopCorner.Y())
			return true;
		return false
	}

	inline bool inside(const CPoint2D<T> &p)
	{
		if ( p.X() > _leftBottomCorner.X() && p.X() < _rightTopCorner.X() && p.Y() > _leftBottomCorner.Y() && p.Y() < _rightTopCorner.Y())
			return true;
		return false;
	}

	inline bool invalide()
	{
		if (width() <= 0 || heigth() <= 0)
			return true;
		return false;
	}

protected:
	CPoint2D<T> _leftBottomCorner;
	CPoint2D<T> _rightTopCorner;
};



#endif


/****************************************************************************
 *                                                                          *
 *  NOTES :                                                                 *
 *                                                                          *
 ****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *    
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *         
 *                                                                          *    
 ****************************************************************************/