/****************************************************************************
 *                                                                          *
 *                  Concours 2006 - GAMES CREATORS NETWORK                  *
 *                                                                          *
 ****************************************************************************

                     PRODUCT          : GRAVITY GAME
 
                     FILE             : Singleton.h

                     VERSION          : 1
 
 ****************************************************************************
 *                                                                          *
 *  DESCRIPTION :                                                           *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          * 
 *                                                                          *  
 ****************************************************************************
 *                                                                          *
 * HISTORY :                                                                * 
 * ---------                                                                *
 *                                                                          *
 *  Date        | Author  | Comment                                         *
 *  ---------------------------------------------------------------------   *
 *  24/07/2006  | Bahamut | Creation                                        *
 *  ---------------------------------------------------------------------   *
 *                                                                          *
 *                                                                          *
 ****************************************************************************/

#ifndef SINGLETON_H
#define SINGLETON_H

// ==============================================
// CSingleton - Singleton Template
// ==============================================

template <typename T> class CSingleton
{
 protected:
  CSingleton(void){/*constructor*/}
  ~CSingleton(void){/*Destructor*/}

 public:
  // ==============================================
  // return unique instanciation
  // ==============================================
  static T * GetInstance(void)
  {
	if( !m_pSingleton )
	m_pSingleton = new T;
	return ( (T *)m_pSingleton );
  }

  // ==============================================
  // Delete unique
  // ==============================================
  void Kill(void)
  {
	if( m_pSingleton )
	{
		delete m_pSingleton;
		m_pSingleton = 0;
	}
  }

 private:
  // unique instanciation
  static T	*m_pSingleton;

  // No copy authorized
  CSingleton(CSingleton&);
  void operator =(CSingleton&);
};


template <typename T> T *CSingleton<T>::m_pSingleton = 0;

#endif




/****************************************************************************
 *                                                                          *
 *  NOTES :                                                                 *
 *                                                                          *
 ****************************************************************************
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *    
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *
 *                                                                          *         
 *                                                                          *    
 ****************************************************************************/
